<?php
/*
    Pull down NextBus data
    API Doc: http://www.nextbus.com/xmlFeedDocs/NextBusXMLFeed.pdf
*/

$agency = "rutgers";

// Required includes
require_once('../config.php');
require_once('../functions.php');

// Open SQL connection
$db = dbc();

// URL
$url = "http://webservices.nextbus.com/service/publicXMLFeed?command=routeConfig&a={$agency}&terse";

// only need to update once a day. unless set otherwise in daemon.
if (!isset($getRouteConfig_waitSeconds)) $getRouteConfig_waitSeconds = 1;

// get timestamp when this selector was last queried
$lastFetched = 0;
$result = dbq($db, "SELECT `time` FROM `lastChecked` WHERE `selector` = 'routeConfig' LIMIT 1");
if ($result->num_rows == 1) {
    $arr = $result->fetch_array();
    $lastFetched = $arr[0];
}

// ask for new data, if needed
if ($lastFetched + $getRouteConfig_waitSeconds < time()) {
    if (@$source = file_get_contents($url)) {
        if ($thisXML = simplexml_load_string($source)) {

            dbq($db, "LOCK TABLES `routes` WRITE, `stops` WRITE, `route_stops` WRITE, `lastChecked` WRITE");

            dbq($db, "DELETE FROM `routes` WHERE `agency` = '{$agency}'");
            dbq($db, "DELETE FROM `stops` WHERE `agency` = '{$agency}'");
            dbq($db, "DELETE FROM `route_stops` WHERE `agency` = '{$agency}'");

            foreach ($thisXML->route as $route) {
                foreach ($route as $key => $val) $route[$key] = $db->real_escape_string($val);
                $q = "INSERT INTO `routes` ";
                $q .= "(`agency`, `tag`,`title`) ";
                $q .= "VALUES ('{$agency}','{$route['tag']}','{$route['title']}')";
                $q .= "ON DUPLICATE KEY UPDATE `tag`='{$route['tag']}', `title`='{$route['title']}'";
                dbq($db, $q);
                foreach ($route->stop as $stop) {
                    foreach ($stop as $key => $val) $stop[$key] = $db->real_escape_string($val);

                    $q = "INSERT INTO `stops` ";
                    $q .= "(`agency`, `tag`,`title`,`lat`,`lon`,`stopId`) ";
                    $q .= "VALUES ('{$agency}','{$stop['tag']}','{$stop['title']}','{$stop['lat']}','{$stop['lon']}','{$stop['stopId']}')";
                    $q .= "ON DUPLICATE KEY UPDATE `title`='{$stop['title']}', `lat`='{$stop['lat']}', `lon`='{$stop['lon']}', `stopId`='{$stop['stopId']}'";
                    dbq($db, $q);

                    $q = "INSERT INTO `route_stops` ";
                    $q .= "(`agency`, `route`, `stop`) ";
                    $q .= "VALUES ('{$agency}','{$route['tag']}', '{$stop['tag']}')";
                    $q .= "ON DUPLICATE KEY UPDATE `stop` = '{$stop['tag']}'";
                    dbq($db, $q);
                }
            }

            dbq($db, "UNLOCK TABLES;");

            // update lastChecked.
            $tSec = time();
            dbq($db, "INSERT INTO `lastChecked` (`selector`, `time`) VALUES ('routeConfig', '" . $tSec . "') ON DUPLICATE KEY UPDATE `time` = VALUES(`time`)");

        } else $warning = "Could not parse NextBus data as XML";
    } else $warning = "Could not fetch NextBus data";
}
$db->close();

?>
