<?php
require_once('config.php');
?>
<!doctype html>
<html lang="en">
<head>
    <title><?php echo $cfg['agency']['name']; ?></title>
    <meta name="description" content=<?php echo json_encode($cfg['agency']['description']); ?>>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width; initial-scale=1; maximum-scale=1; user-scalable=no;" />
    <meta name="apple-mobile-web-app-capable" content="yes" />
    <meta name="apple-mobile-web-app-status-bar-style" content="black" />
    <link href="css/leaflet.css" rel="stylesheet" />
    <link href="css/leaflet.label.css" rel="stylesheet" />
    <link href="css/style.css" rel="stylesheet" />
<?php if (isset($_GET['embed'])): ?>
    <link href="css/embed.css" rel="stylesheet" />
<?php endif; ?>
    <script>
        window.agency = <?php echo json_encode($cfg['agency']['shortname']); ?>;
        window.busIconUrl = <?php echo json_encode($cfg['agency']['busIconUrl'], JSON_UNESCAPED_SLASHES); ?>;
    </script>
    <script src="js/fastclick.js"></script>
    <script src="js/jquery.min.js"></script>
    <script src="js/leaflet.js"></script>
    <script src="js/leaflet.marker.rotate.js"></script>
    <script src="js/leaflet.label.js"></script>
    <script src="js/jquery.raptorize.js"></script>
    <script src="js/script.js"></script>
    <script>
    $(document).ready(function() {
        // setup and create tile layer on map
        L.tileLayer(<?php echo json_encode($cfg['agency']['tileUrl'], JSON_UNESCAPED_SLASHES); ?>, {
            subdomains: <?php echo json_encode($cfg['agency']['tileSubdomains']); ?>,
            tileset: <?php echo json_encode($cfg['agency']['tileset']); ?>,
            errorTileUrl: <?php echo json_encode($cfg['agency']['errorTileUrl'], JSON_UNESCAPED_SLASHES); ?>,
            attribution: <?php echo json_encode($cfg['agency']['attribution'], JSON_UNESCAPED_SLASHES); ?>,
            detectRetina: true,
        }).addTo(window.map);
    });
    </script>
    <?php
        // Set initial lat/lon if requested.
        if (isset($_GET['centerLat']) && isset($_GET['centerLon'])) {
            // sanitize user inputs by converting them to doubles/ints.
            $lat = doubleval($_GET['centerLat']);
            $lon = doubleval($_GET['centerLon']);
            if (isset($_GET['zoom'])) $zoom = intval($_GET['zoom']);
            else $zoom = 'undefined';
            echo '<script>$(document).ready(function(){ window.map.setView(['.$lat.','.$lon.'], '.$zoom.'); });</script>';
        }
    ?>
</head>
<body>
    <div id="container">
        <div id="topBar">
            <div id="routeselector">Please enable Javascript to use this map.</div>
        </div>
        <div id="map"></div>
        <div id="locationButton"></div>
    </div>
</body>
</html>
